function Read-Input {
  param(
    [String] $Prompt,
    [String] $InitialValue,
    [Switch] $Hidden
  )
  $arguments = '-p "{0}" ' -f $Prompt
  if ( $Hidden ) { $arguments += " -h " }
  $arguments += " -- {0}" -f $InitialValue
  $process = New-Object System.Diagnostics.Process
  $process.StartInfo.FileName = (get-command "ReadLine.exe").Definition
  $process.StartInfo.Arguments = $arguments
  $process.StartInfo.UseShellExecute = $false
  $process.StartInfo.RedirectStandardOutput = $true
  if ( $process.Start() ) {
    $process.StandardOutput.ReadToEnd() -replace "\r\n$",""
  }
}
$path = Read-Input -Prompt "PATH=" -InitialValue $Env:Path
if ( $path -eq "" ) {
  throw "Empty path not permitted"
}
else {
  $Env:Path = $path
}
